#ifndef MSP_GL_GRID_H_
#define MSP_GL_GRID_H_

#include "geometrybuilder.h"
#include "vector.h"

namespace Msp {
namespace GL {

class GridBuilder: public GeometryBuilder
{
private:
	Vector3 origin;
	Vector3 side1;
	Vector3 side2;
	Vector3 norm;
	Vector3 binorm;
	unsigned u_div;
	unsigned v_div;

public:
	GridBuilder(float, float, unsigned = 4, unsigned = 4);
	GridBuilder(const Vector3 &, const Vector3 &, unsigned = 4, unsigned = 4);
	GridBuilder(const Vector3 &, const Vector3 &, const Vector3 &, unsigned = 4, unsigned = 4);
private:
	void init(bool);

public:
	using GeometryBuilder::build;
	virtual void build(PrimitiveBuilder &) const;
};

} // namespace GL
} // namespace Msp

#endif
